"use strict";

var type = require("type-of"),
    listUtil = require("./util/list");

var search = function search(path, a, b, ia, ib, match, delta, records) {
  undefined;
  var isAEnd = a.length === 0,
      isBEnd = b.length === 0,
      bothEnd = isAEnd && isBEnd;
  return (function () {
    switch (true) {
      case bothEnd:
        return [record(match, delta, records)];

      case isAEnd:
        var bFirst = b[0];
        return search(path, [], b.slice(1), ia, ib + 1, match, delta + 1, records.concat(op("+", path, ib, bFirst)));

      case isBEnd:
        var aFirst = a[0];
        return search(path, a.slice(1), [], ia + 1, ib, match, delta + 1, records.concat(op("-", path, ib, aFirst)));

      default:
        var aFirst = a[0],
            bFirst = b[0],
            isMatch = aFirst === bFirst,
            bothList = type(aFirst) === "array" && type(bFirst) === "array";
        return (function () {
          switch (true) {
            case isMatch:
              return search(path, a.slice(1), b.slice(1), ia + 1, ib + 1, match + 1, delta, records);

            case bothList:
              var bestResult = searchOne(path.concat(ib), aFirst, bFirst, records);
              return bestResult.match > bestResult.delta ? search(path, a.slice(1), b.slice(1), ia + 1, ib + 1, match + bestResult.match + 1, delta + bestResult.delta, bestResult.records) : searchBranch(path, a, b, ia, ib, match, delta, records);

            default:
              return searchBranch(path, a, b, ia, ib, match, delta, records);
          }
        })();
    }
  })();
};

var searchBranch = function searchBranch(path, a, b, ia, ib, match, delta, records) {
  var aFirst = a[0],
      bFirst = b[0];
  return listUtil.manualConcat(search(path, a.slice(1), b, ia + 1, ib, match, delta + 1, records.concat(op("-", path, ib, aFirst))), search(path, a, b.slice(1), ia, ib + 1, match, delta + 1, records.concat(op("+", path, ib, bFirst))));
};

var op = function op(name, path, index, value) {
  return {
    op: name,
    path: path.concat(index),
    value: value
  };
};

var record = function record(match, delta, records) {
  return {
    match: match,
    delta: delta,
    records: records
  };
};

var searchOne = function searchOne(path, a, b, records) {
  var allResults = search(path, a, b, 0, 0, 0, 0, records);
  return listUtil.findMaxHelper(allResults, null, function (x) {
    return x.match - x.delta;
  });
};

module.exports = function (a, b) {
  return searchOne([], a, b, []);
};