"use strict";

var listUtil = require("./util/list");

var insertHelper = function insertHelper(_x, _x2, _x3, _x4) {
  var _again = true;

  _function: while (_again) {
    var list = _x,
        index = _x2,
        value = _x3,
        result = _x4;
    _again = false;

    if (index === 0) {
      return result.concat([value], list.slice(1));
    } else {
      _x = list.slice(1);
      _x2 = index - 1;
      _x3 = value;
      _x4 = result.concat([list[0]]);
      _again = true;
      continue _function;
    }
  }
};

var removeHelper = function removeHelper(_x5, _x6, _x7) {
  var _again2 = true;

  _function2: while (_again2) {
    var list = _x5,
        index = _x6,
        result = _x7;
    _again2 = false;

    if (index === 0) {
      return result.concat(list.slice(1));
    } else {
      _x5 = list.slice(1);
      _x6 = index - 1;
      _x7 = result.concat([list[0]]);
      _again2 = true;
      continue _function2;
    }
  }
};

var patchTree = function patchTree(original, change) {
  undefined;
  return (function () {
    switch (true) {
      case change.path.length > 1:
        var pathHead = change.path[0];
        var nestedChange = {
          op: change.op,
          path: change.path.slice(1),
          value: change.value
        };
        return listUtil.flatMap(original, function (item, index) {
          return index === pathHead ? [patchTree(item, nestedChange)] : [item];
        });

      case change.path.length === 1:
        var pathHead = change.path[0];
        return (function () {
          switch (true) {
            case change.op === "-":
              return removeHelper(original, pathHead, []);

            case change.op === "+":
              return insertHelper(original, pathHead, change.value, []);

            default:
              throw "unknow op";
              return undefined;
          }
        })();

      default:
        throw "empty path is invalid";
        return undefined;
    }
  })();
};

var updateTree = function updateTree(_x8, _x9) {
  var _again3 = true;

  _function3: while (_again3) {
    var original = _x8,
        records = _x9;
    _again3 = false;

    if (records.length === 0) {
      return original;
    } else {
      _x8 = patchTree(original, records[0]);
      _x9 = records.slice(1);
      _again3 = true;
      continue _function3;
    }
  }
};

module.exports = function (original, diff) {
  return updateTree(original, diff.records);
};